package com.diagbot.repository;


import com.alibaba.fastjson.JSONObject;
import com.diagbot.biz.push.entity.Item;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.OperationBillNeoDTO;
import com.diagbot.dto.OperationInfoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.entity.node.ClinicalFinding;
import com.diagbot.entity.node.ConflictDevice;
import com.diagbot.entity.node.Disease;
import com.diagbot.entity.node.Gender;
import com.diagbot.entity.node.Group;
import com.diagbot.entity.node.Lis;
import com.diagbot.entity.node.MedAllergen;
import com.diagbot.entity.node.OralMedicine;
import com.diagbot.entity.node.PacsDescribe;
import com.diagbot.entity.node.Vital;
import com.diagbot.entity.node.YiBaoOperationName;
import com.diagbot.entity.relationship.YiBaoOperationNameClinicalFinding;
import com.diagbot.entity.relationship.YiBaoOperationNameConflictDevice;
import com.diagbot.entity.relationship.YiBaoOperationNameDisease;
import com.diagbot.entity.relationship.YiBaoOperationNameGender;
import com.diagbot.entity.relationship.YiBaoOperationNameGroup;
import com.diagbot.entity.relationship.YiBaoOperationNameLis;
import com.diagbot.entity.relationship.YiBaoOperationNameMedAllergen;
import com.diagbot.entity.relationship.YiBaoOperationNameOralMedicine;
import com.diagbot.entity.relationship.YiBaoOperationNamePacsDescribe;
import com.diagbot.entity.relationship.YiBaoOperationNameVital;
import com.diagbot.enums.TypeEnum;
import com.diagbot.model.label.PacsLabel;
import com.diagbot.model.label.VitalLabel;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;
import com.diagbot.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

@Component
public class YiBaoOperationNameNode {

    @Autowired
    MedAllergenRepository medAllergenRepository;
    @Autowired
    GenderRepository genderRepository;
    @Autowired
    LisRepository lisRepository;
    @Autowired
    GroupRepository groupRepository;
    @Autowired
    ClinicalFindingRepository clinicalFindingRepository;
    @Autowired
    VitalRepository vitalRepository;
    @Autowired
    AgeRepository ageRepository;
    @Autowired
    DiseaseRepository diseaseRepository;
    @Autowired
    BillConflictItemRepository billConflictItemRepository;
    @Autowired
    ConflictDeviceRepository conflictDeviceRepository;
    @Autowired
    OralMedicineRepository oralMedicineRepository;
    @Autowired
    PacsDescribeRepository pacsDescribeRepository;
    @Autowired
    AllergenRepository allergenRepository;


    public OperationBillNeoDTO YiBaoOperationtoOperationDTO(YiBaoOperationName operation) {
        OperationBillNeoDTO opBillNeoDTO = new OperationBillNeoDTO();
        NodeInfo nodeInfo;

        YiBaoOperationNameGender yiBaoOperationNameGender = operation.getGender();
        if (NeoUtil.isExist(yiBaoOperationNameGender)) {
            if (NeoUtil.isExist(yiBaoOperationNameGender.getGender())) {
                Gender gender = yiBaoOperationNameGender.getGender();
                nodeInfo = new NodeInfo();
                nodeInfo.setName(gender.getName());
                nodeInfo.setTypeval(Constants.gender);
                opBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }

        Set<YiBaoOperationNameClinicalFinding> yibaoOperationNameclinicalfindings = operation.getClinicalFindings();
        for (YiBaoOperationNameClinicalFinding yiBaoOperationNameclinicalfinding : yibaoOperationNameclinicalfindings) {
            if (NeoUtil.isExist(yiBaoOperationNameclinicalfinding)) {
                if (NeoUtil.isExist(yiBaoOperationNameclinicalfinding.getClinicalFinding())) {
                    ClinicalFinding clinicalfinding = yiBaoOperationNameclinicalfinding.getClinicalFinding();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(clinicalfinding.getName());
                    nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMinval()));
                    nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMaxval()));
                    nodeInfo.setUnit(clinicalfinding.getUnit());
                    nodeInfo.setRange(clinicalfinding.getRange());
                    nodeInfo.setTypeval(Constants.clinicalfinding);
                    opBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameVital> yiBaoOperationNamevitals = operation.getVitals();
        for (YiBaoOperationNameVital yiBaoOperationNamevital : yiBaoOperationNamevitals) {
            if (NeoUtil.isExist(yiBaoOperationNamevital)) {
                if (NeoUtil.isExist(yiBaoOperationNamevital.getVital())) {
                    Vital vital = yiBaoOperationNamevital.getVital();
                    nodeInfo = new NodeInfo();
                    String name = vital.getVitalidx();
                    nodeInfo.setName(name);
                    nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(vital.getMinval()));
                    nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(vital.getMaxval()));
                    nodeInfo.setUnit(vital.getUnit());
                    nodeInfo.setRange(vital.getRange());
                    nodeInfo.setTypeval(Constants.vital);
                    if (name.equals(Constants.age)) {
                        opBillNeoDTO.setAgeNeoDTO(NeoUtil.updateNodeInfo(nodeInfo));
                    }
                    else {
                        opBillNeoDTO.getVitals().add(NeoUtil.updateNodeInfo(nodeInfo));
                    }
                }
            }
        }

        Set<YiBaoOperationNameLis> yiBaoOperationNameLisSet = operation.getLiss();
        for (YiBaoOperationNameLis yiBaoOperationNameLis : yiBaoOperationNameLisSet) {
            if (NeoUtil.isExist(yiBaoOperationNameLis)) {
                if (NeoUtil.isExist(yiBaoOperationNameLis.getLis())) {
                    Lis lis = yiBaoOperationNameLis.getLis();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(lis.getLisidx());
                    nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(lis.getMinval()));
                    nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(lis.getMaxval()));
                    nodeInfo.setUnit(lis.getUnit());
                    nodeInfo.setRange(lis.getRange());
                    nodeInfo.setTypeval(Constants.lis);
                    opBillNeoDTO.getLis().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameOralMedicine> yiBaoOperationNameOralMeds = operation.getOralmeds();
        for (YiBaoOperationNameOralMedicine yiBaoOperationNameOralMed : yiBaoOperationNameOralMeds) {
            if (NeoUtil.isExist(yiBaoOperationNameOralMed)) {
                if (NeoUtil.isExist(yiBaoOperationNameOralMed.getOralMedicine())) {
                    OralMedicine conflict_oralmed = yiBaoOperationNameOralMed.getOralMedicine();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(conflict_oralmed.getName());
                    nodeInfo.setTypeval(Constants.yaoping);
                    opBillNeoDTO.getOralmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameDisease> yiBaoOperationNameDiseases = operation.getDiseases();
        for (YiBaoOperationNameDisease yiBaoOperationNameDisease : yiBaoOperationNameDiseases) {
            if (NeoUtil.isExist(yiBaoOperationNameDisease)) {
                if (NeoUtil.isExist(yiBaoOperationNameDisease.getDisease())) {
                    Disease disease = yiBaoOperationNameDisease.getDisease();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(disease.getName());
                    nodeInfo.setTypeval(Constants.disease);
                    opBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameGroup> yiBaoOperationNameGroups = operation.getGroups();
        for (YiBaoOperationNameGroup conflict_group : yiBaoOperationNameGroups) {
            if (NeoUtil.isExist(conflict_group)) {
                if (NeoUtil.isExist(conflict_group.getGroup())) {
                    Group group = conflict_group.getGroup();
                    String name = (group.getGroupidx()==null)?group.getName():group.getGroupidx();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(name);
                    nodeInfo.setTypeval(Constants.group);
                    opBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNamePacsDescribe> yiBaoOperationNamePacsDescribes = operation.getPacsdescs();
        for (YiBaoOperationNamePacsDescribe yiBaoOperationNamePacsDescribe : yiBaoOperationNamePacsDescribes) {
            if (NeoUtil.isExist(yiBaoOperationNamePacsDescribe)) {
                if (NeoUtil.isExist(yiBaoOperationNamePacsDescribe.getPacsDescribe())) {
                    PacsDescribe pacsdesc = yiBaoOperationNamePacsDescribe.getPacsDescribe();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(pacsdesc.getName());
                    nodeInfo.setTypeval(Constants.pacsdesc);
                    opBillNeoDTO.getPacsDesc().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameMedAllergen> yiBaoOperationNameMedAllergens = operation.getMedallergens();
        for (YiBaoOperationNameMedAllergen yiBaoOperationNameMedAllergen : yiBaoOperationNameMedAllergens) {
            if (NeoUtil.isExist(yiBaoOperationNameMedAllergen)) {
                if (NeoUtil.isExist(yiBaoOperationNameMedAllergen.getMedAllergen())) {
                    MedAllergen medAllergen = yiBaoOperationNameMedAllergen.getMedAllergen();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(medAllergen.getName());
                    nodeInfo.setTypeval(NeoUtil.getMedType(medAllergen.getName()));
                    opBillNeoDTO.getMedallegen().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameConflictDevice> yiBaoOperationNameConflictDevices = operation.getConflictdevices();
        for (YiBaoOperationNameConflictDevice yiBaoOperationNameConflictDevice : yiBaoOperationNameConflictDevices) {
            if (NeoUtil.isExist(yiBaoOperationNameConflictDevice)) {
                if (NeoUtil.isExist(yiBaoOperationNameConflictDevice.getConflictDevice())) {
                    ConflictDevice device = yiBaoOperationNameConflictDevice.getConflictDevice();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(device.getName());
                    nodeInfo.setTypeval(Constants.conflictdevice);
                    opBillNeoDTO.getMeddevice().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        return opBillNeoDTO;
    }

    /**
     * 处理手术开单合理性
     */
    public List<BillNeoDTO> getOperationBill(List<Map<String, String>> optermlist, YiBaoOperationNameRepository opRepository) {
        List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
        BillNeoDTO billNeoDTO;

        OperationBillNeoDTO opBillNeoDTO;

        String opname;

        for (Map<String, String> opterm : optermlist) {
            for (String term : opterm.keySet()) {
                billNeoDTO = new BillNeoDTO();
                opname = opterm.get(term);
                billNeoDTO.setName(term);
                billNeoDTO.setStandname(opname);

                List<YiBaoOperationName> operations = opRepository.findByNameIs(opname);

                if (ListUtil.isNotEmpty(operations)) {
                    opBillNeoDTO = YiBaoOperationtoOperationDTO(operations.get(0));
                    billNeoDTO.setOperationBillNeoDTO(opBillNeoDTO);
                }

                billNeoDTOs.add(billNeoDTO);
            }
        }

        return billNeoDTOs;
    }

    /**
     * 获取手术操作名称列表
     */
    public List<OperationInfoDTO> getOperationList(String name, Integer size, YiBaoOperationNameRepository operationRepository, BaseNodeRepository baseNodeRepository) {
        String nodename;

        List<OperationInfoDTO> opslist = new ArrayList<>();
        OperationInfoDTO opInfoDTO;

        if (null == size) {
            size = 100;
        }

        List<YiBaoOperationName> operations = operationRepository.index(name, name, size);

        if (ListUtil.isNotEmpty(operations) && operations.size() > size) {
            operations = operations.subList(0, size);
        }

        for (YiBaoOperationName op : operations) {
            opInfoDTO = new OperationInfoDTO();
            nodename = op.getName();

            opInfoDTO.setName(nodename);
            opslist.add(opInfoDTO);
        }

        return opslist;
    }


    /**
     * 获取高危手术和操作数据
     */
    public List<HighRiskNeoDTO> getHighRiskOperation(WordCrfDTO wordCrfDTO, YiBaoOperationNameRepository operationRepository) {
        List<HighRiskNeoDTO> highRiskNeoDTOS = new ArrayList<>();
        HighRiskNeoDTO highRiskNeoDTO;
        String term, opname, opgrade;
        YiBaoOperationName operation;

        for (Item item : wordCrfDTO.getOperationOrder()) {
            highRiskNeoDTO = new HighRiskNeoDTO();

            term = item.getName().trim();
            opname = item.getUniqueName().trim();
            highRiskNeoDTO.setName(term);
            highRiskNeoDTO.setStandname(opname);

            List<YiBaoOperationName> operations = operationRepository.findByNameIs(opname);

            if (ListUtil.isNotEmpty(operations)) {
                operation = operations.get(0);
                if (null != operation.getOpgrade() && operation.getOpgrade().trim().length() > 0) {
                    opgrade = operation.getOpgrade().trim();
                    if (opgrade.equals("3") || opgrade.equals("4")) {
                        highRiskNeoDTO.setIsHighrisk(true);
                        highRiskNeoDTO.setHighLevel(opgrade);
                        highRiskNeoDTO.setType(Constants.shoushu);
                        highRiskNeoDTOS.add(highRiskNeoDTO);
                    } else if (opgrade.equals("2")) {
                        highRiskNeoDTO = isHighRisk(wordCrfDTO, operation, highRiskNeoDTO);
                        if (null != highRiskNeoDTO) {
                            highRiskNeoDTOS.add(highRiskNeoDTO);
                        }
                    }
                }
            }
        }

        return highRiskNeoDTOS;
    }


    /**
     * 获取手术和操作名称
     */
    public List<OperationInfoDTO> getOperationNameList(String name, Integer size, YiBaoOperationNameRepository operationRepository) {

        String nodename;

        List<OperationInfoDTO> opslist = new ArrayList<>();
        OperationInfoDTO opInfoDTO;

        if (null == size || size == 0) {
            size = Constants.termsize;
        }

        List<String> operations = operationRepository.getOperationNames(size);

        for (String opname : operations) {
            opInfoDTO = new OperationInfoDTO();
            opInfoDTO.setName(opname);
            opslist.add(opInfoDTO);
        }

        return opslist;
    }


    public HighRiskNeoDTO isHighRisk(WordCrfDTO wordCrfDTO, YiBaoOperationName operation, HighRiskNeoDTO highRiskNeoDTO) {

        NodeNeoDTO nodeNeoDTO;
        Boolean match;
        Map<String, Object> res;

        try {
            String cond = operation.getHighriskcond();
            JSONObject jobj = JSONObject.parseObject(cond);

            if (null != jobj) {
                // 判断年龄
                JSONObject ageobj = jobj.getJSONObject("年龄");

                nodeNeoDTO = NeoUtil.jsontoNodeNeoDTO("年龄", ageobj);
                if (null != wordCrfDTO.getAgeNum()) {
                    double age = wordCrfDTO.getAgeNum();
                    match = CoreUtil.compareNum(nodeNeoDTO, age);
                    if (match) {
                        nodeNeoDTO.setName("年龄:" + CoreUtil.subZeroAndDot(String.valueOf(age)));
                        nodeNeoDTO.setVal("年龄:" + CoreUtil.subZeroAndDot(String.valueOf(age)));
                        nodeNeoDTO.setTermtype(TypeEnum.age.getName());
                        highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                    }
                }

                // 判断生命体征和查体
                VitalLabel vitalLabel = wordCrfDTO.getVitalLabel();
                JSONObject vitalobj = jobj.getJSONObject("生命体征及查体");
                for (String key : vitalobj.keySet()) {
                    nodeNeoDTO = NeoUtil.jsontoNodeNeoDTO(key, vitalobj.getJSONObject(key));
                    res = CoreUtil.compareVital(nodeNeoDTO, vitalLabel);

                    if ((Boolean) res.get("flag")) {
                        nodeNeoDTO.setVal(res.get("msg").toString());
                        nodeNeoDTO.setTermtype(TypeEnum.vital.getName());
                        highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                    }
                }

                // 判断合并疾病
                List<Item> diags = wordCrfDTO.getDiag();
                JSONObject diagobj = jobj.getJSONObject("合并疾病");
                for (String key : diagobj.keySet()) {
                    for (Item item : diags) {
                        if (StringUtil.isNotBlank(item.getUniqueName()) && item.getUniqueName().equals(key)) {
                            nodeNeoDTO = new NodeNeoDTO();
                            nodeNeoDTO.setName(item.getUniqueName());
                            nodeNeoDTO.setVal(item.getName());
                            nodeNeoDTO.setTermtype(TypeEnum.disease.getName());
                            highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                        }
                    }
                }

                // 判断化验结果
                List<com.diagbot.biz.push.entity.Lis> lislist = wordCrfDTO.getLis();
                JSONObject lisobj = jobj.getJSONObject("化验结果");
                for (String key : lisobj.keySet()) {
                    nodeNeoDTO = NeoUtil.jsontoNodeNeoDTO(key, lisobj.getJSONObject(key));
                    for (com.diagbot.biz.push.entity.Lis lis : lislist) {
                        String name = lis.getUniqueName();
                        if (nodeNeoDTO.getName().equals(name)) {
                            res = CoreUtil.compareLis(nodeNeoDTO, lis);

                            if ((Boolean) res.get("flag")) {
                                nodeNeoDTO.setVal(res.get("msg").toString());
                                nodeNeoDTO.setTermtype(TypeEnum.lis.getName());
                                highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                            }
                        }
                    }
                }

                // 判断辅检结果
                PacsLabel pacslbl = wordCrfDTO.getPacsLabel();

                JSONObject pacsobj = jobj.getJSONObject("辅检结果描述");
                for (String key : pacsobj.keySet()) {

                    for (Item item : pacslbl.getRes()) {
                        if (StringUtil.isNotBlank(item.getUniqueName()) && item.getUniqueName().contains(key)) {
                            nodeNeoDTO = new NodeNeoDTO();
                            nodeNeoDTO.setName(item.getUniqueName());
                            nodeNeoDTO.setVal(item.getUniqueName());
                            nodeNeoDTO.setTermtype(TypeEnum.pacs.getName());
                            highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                        }
                    }
                }

                if (highRiskNeoDTO.getFactor().size() > 0) {
                    highRiskNeoDTO.setType(TypeEnum.operation.getName());
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            return highRiskNeoDTO;
        }

    }

    /**
     * 更新关系状态属性
     */
    public void updateRelationExt(YiBaoOperationName yiBaoOperationName, String relname, Integer status, Integer ruleType, String e_name, YiBaoOperationNameRepository yiBaoOperationNameRepository) {
        Boolean isExist = false;
        try {
            switch (relname) {
                case "医保手术和操作名称禁忌性别":
                    Gender gender = genderRepository.findByNameIs(e_name).get(0);
                    YiBaoOperationNameGender yiBaoOperationNameGender = new YiBaoOperationNameGender();
                    yiBaoOperationNameGender.setGender(gender);
                    yiBaoOperationNameGender.setYiBaoOperationName(yiBaoOperationName);
                    yiBaoOperationNameGender.setStatus(status);
                    yiBaoOperationNameGender.setRuleType(ruleType);
                    yiBaoOperationName.setGender(yiBaoOperationNameGender);
                    break;
                case "医保手术和操作名称禁忌禁忌人群":
                    Group group = groupRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameGroup> yiBaoOperationNameGroupSet = yiBaoOperationName.getGroups();
                    isExist = false;
                    for (YiBaoOperationNameGroup item : yiBaoOperationNameGroupSet) {
                        if (item.getGroup() != null
                                && item.getGroup().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setGroup(group);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameGroup yiBaoOperationNameGroup = new YiBaoOperationNameGroup();
                        yiBaoOperationNameGroup.setGroup(group);
                        yiBaoOperationNameGroup.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameGroup.setStatus(status);
                        yiBaoOperationNameGroup.setRuleType(ruleType);
                        yiBaoOperationNameGroupSet.add(yiBaoOperationNameGroup);
                    }
                    yiBaoOperationName.setGroups(yiBaoOperationNameGroupSet);
                    break;
                case "医保手术和操作名称禁忌药物过敏原":
                    MedAllergen medAllergen = medAllergenRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameMedAllergen> yiBaoOperationNameMedAllergenSet = yiBaoOperationName.getMedallergens();
                    isExist = false;
                    for (YiBaoOperationNameMedAllergen item : yiBaoOperationNameMedAllergenSet) {
                        if (item.getMedAllergen() != null
                                && item.getMedAllergen().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setMedAllergen(medAllergen);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameMedAllergen yiBaoOperationNameMedAllergen = new YiBaoOperationNameMedAllergen();
                        yiBaoOperationNameMedAllergen.setMedAllergen(medAllergen);
                        yiBaoOperationNameMedAllergen.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameMedAllergen.setStatus(status);
                        yiBaoOperationNameMedAllergen.setRuleType(ruleType);
                        yiBaoOperationNameMedAllergenSet.add(yiBaoOperationNameMedAllergen);
                    }
                    yiBaoOperationName.setMedallergens(yiBaoOperationNameMedAllergenSet);
                    break;
                case "医保手术和操作名称禁忌临床表现":
                    ClinicalFinding clinicalFinding = clinicalFindingRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameClinicalFinding> yiBaoOperationNameClinicalFindingSet = yiBaoOperationName.getClinicalFindings();
                    isExist = false;
                    for (YiBaoOperationNameClinicalFinding item : yiBaoOperationNameClinicalFindingSet) {
                        if (item.getClinicalFinding() != null
                                && item.getClinicalFinding().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setClinicalFinding(clinicalFinding);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameClinicalFinding yiBaoOperationNameClinicalFinding = new YiBaoOperationNameClinicalFinding();
                        yiBaoOperationNameClinicalFinding.setClinicalFinding(clinicalFinding);
                        yiBaoOperationNameClinicalFinding.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameClinicalFinding.setStatus(status);
                        yiBaoOperationNameClinicalFinding.setRuleType(ruleType);
                        yiBaoOperationNameClinicalFindingSet.add(yiBaoOperationNameClinicalFinding);
                    }
                    yiBaoOperationName.setClinicalFindings(yiBaoOperationNameClinicalFindingSet);
                    break;
                case "医保手术和操作名称禁忌实验室检查":
                    Lis lis = lisRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameLis> yiBaoOperationNameLisSet = yiBaoOperationName.getLiss();
                    isExist = false;
                    for (YiBaoOperationNameLis item : yiBaoOperationNameLisSet) {
                        if (item.getLis() != null
                                && item.getLis().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setLis(lis);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameLis yiBaoOperationNameLis = new YiBaoOperationNameLis();
                        yiBaoOperationNameLis.setLis(lis);
                        yiBaoOperationNameLis.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameLis.setStatus(status);
                        yiBaoOperationNameLis.setRuleType(ruleType);
                        yiBaoOperationNameLisSet.add(yiBaoOperationNameLis);
                    }
                    yiBaoOperationName.setLiss(yiBaoOperationNameLisSet);
                    break;
                case "医保手术和操作名称禁忌疾病":
                    Disease disease = diseaseRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameDisease> yiBaoOperationNameDiseaseSet = yiBaoOperationName.getDiseases();
                    isExist = false;
                    for (YiBaoOperationNameDisease item : yiBaoOperationNameDiseaseSet) {
                        if (item.getDisease() != null
                                && item.getDisease().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setDisease(disease);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameDisease yiBaoOperationNameDisease = new YiBaoOperationNameDisease();
                        yiBaoOperationNameDisease.setDisease(disease);
                        yiBaoOperationNameDisease.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameDisease.setStatus(status);
                        yiBaoOperationNameDisease.setRuleType(ruleType);
                        yiBaoOperationNameDiseaseSet.add(yiBaoOperationNameDisease);
                    }
                    yiBaoOperationName.setDiseases(yiBaoOperationNameDiseaseSet);
                    break;
                case "医保手术和操作名称禁忌禁忌医疗器械及物品":
                    ConflictDevice conflictDevice = conflictDeviceRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameConflictDevice> yiBaoOperationNameConflictDeviceSet = yiBaoOperationName.getConflictdevices();
                    isExist = false;
                    for (YiBaoOperationNameConflictDevice item : yiBaoOperationNameConflictDeviceSet) {
                        if (item.getConflictDevice() != null
                                && item.getConflictDevice().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setConflictDevice(conflictDevice);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameConflictDevice yiBaoOperationNameConflictDevice = new YiBaoOperationNameConflictDevice();
                        yiBaoOperationNameConflictDevice.setConflictDevice(conflictDevice);
                        yiBaoOperationNameConflictDevice.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameConflictDevice.setStatus(status);
                        yiBaoOperationNameConflictDevice.setRuleType(ruleType);
                        yiBaoOperationNameConflictDeviceSet.add(yiBaoOperationNameConflictDevice);
                    }
                    yiBaoOperationName.setConflictdevices(yiBaoOperationNameConflictDeviceSet);
                    break;
                case "医保手术和操作名称禁忌体征":
                    Vital vital = vitalRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameVital> yiBaoOperationNameVitalSet = yiBaoOperationName.getVitals();
                    isExist = false;
                    for (YiBaoOperationNameVital item : yiBaoOperationNameVitalSet) {
                        if (item.getVital() != null
                                && item.getVital().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setVital(vital);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameVital yiBaoOperationNameVital = new YiBaoOperationNameVital();
                        yiBaoOperationNameVital.setVital(vital);
                        yiBaoOperationNameVital.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameVital.setStatus(status);
                        yiBaoOperationNameVital.setRuleType(ruleType);
                        yiBaoOperationNameVitalSet.add(yiBaoOperationNameVital);
                    }
                    yiBaoOperationName.setVitals(yiBaoOperationNameVitalSet);
                    break;
                case "医保手术和操作名称禁忌服用药品":
                    OralMedicine oralMedicine = oralMedicineRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNameOralMedicine> yiBaoOperationNameOralMedicineSet = yiBaoOperationName.getOralmeds();
                    isExist = false;
                    for (YiBaoOperationNameOralMedicine item : yiBaoOperationNameOralMedicineSet) {
                        if (item.getOralMedicine() != null
                                && item.getOralMedicine().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setOralMedicine(oralMedicine);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNameOralMedicine yiBaoOperationNameOralMedicine = new YiBaoOperationNameOralMedicine();
                        yiBaoOperationNameOralMedicine.setOralMedicine(oralMedicine);
                        yiBaoOperationNameOralMedicine.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNameOralMedicine.setStatus(status);
                        yiBaoOperationNameOralMedicine.setRuleType(ruleType);
                        yiBaoOperationNameOralMedicineSet.add(yiBaoOperationNameOralMedicine);
                    }
                    yiBaoOperationName.setOralmeds(yiBaoOperationNameOralMedicineSet);
                    break;
                case "医保手术和操作名称禁忌辅助检查名称描述":
                    PacsDescribe pacsDescribe = pacsDescribeRepository.findByNameIs(e_name).get(0);
                    Set<YiBaoOperationNamePacsDescribe> yiBaoOperationNamePacsDescribeSet = yiBaoOperationName.getPacsdescs();
                    isExist = false;
                    for (YiBaoOperationNamePacsDescribe item : yiBaoOperationNamePacsDescribeSet) {
                        if (item.getPacsDescribe() != null
                                && item.getPacsDescribe().getName().equals(e_name)) {
                            isExist = true;
                            item.setYiBaoOperationName(yiBaoOperationName);
                            item.setPacsDescribe(pacsDescribe);
                            item.setStatus(status);
                            item.setRuleType(ruleType);
                        }
                    }
                    if (!isExist) {
                        YiBaoOperationNamePacsDescribe yiBaoOperationNamePacsDescribe = new YiBaoOperationNamePacsDescribe();
                        yiBaoOperationNamePacsDescribe.setPacsDescribe(pacsDescribe);
                        yiBaoOperationNamePacsDescribe.setYiBaoOperationName(yiBaoOperationName);
                        yiBaoOperationNamePacsDescribe.setStatus(status);
                        yiBaoOperationNamePacsDescribe.setRuleType(ruleType);
                        yiBaoOperationNamePacsDescribeSet.add(yiBaoOperationNamePacsDescribe);
                    }
                    yiBaoOperationName.setPacsdescs(yiBaoOperationNamePacsDescribeSet);
                    break;
            }
            yiBaoOperationNameRepository.save(yiBaoOperationName, 1);
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {

        }
    }
}